//////////////////////////////////////////////////////////////
//	: tbag.cpp											//
//	 ' '         	//
//	Copyright (c) 2010-2013   	//
//////////////////////////////////////////////////////////////

#include "tbag.h"

#include <malloc.h>
#include <string.h>

namespace Taskbag {
TBag::Task::Task()
{
	buf=malloc(ALLOC_SIZE);
	size=ALLOC_SIZE;
	cur=0;
}

TBag::Task::~Task()
{
	free(buf);
}
		
void TBag::Task::send(void*p,size_t s)
{
	while(cur+s>size){buf=realloc(buf,size+ALLOC_SIZE);size+=ALLOC_SIZE;}
	memmove(buf,p,s);cur+=s;
}

void TBag::Task::recv(void*p,size_t s)
{
	memmove(p,(char*)buf+cur,s);cur+=s;
}

void TBag::run()
{
	task=createTask();
	while(if_job()){
		get(task);/////////////////////////
		task->cur=0;task->send_task();
		task->cur=0;task->recv_task();
		proc(task);////////////////////////
		task->cur=0;task->send_result();
		task->cur=0;task->recv_result();
		put(task);/////////////////////////
	}
	delete task;
}

}